#include <PS2X_lib.h>  //для v1.6

#define PS2_DAT        7  //14    
#define PS2_CMD        6  //15
#define PS2_SEL        5  //16
#define PS2_CLK        4  //17

/******************************************************************
   выберете режимы PS2 контроллера:
     - pressures = аналоговое считывание нажатия кнопок
     - rumble    = вибромоторы
   откройте или закройте комментарием каждую функцию
 ******************************************************************/
//#define pressures   true
#define pressures   false
//#define rumble      true
#define rumble      false

#define right_wheel_forward 11
#define right_wheel_back 12
#define left_wheel_forward 9
#define left_wheel_back 8
#define speed_right_wheel 13
#define speed_left_wheel 10
#define pump_pin 3

PS2X ps2x; // создание класса для PS2 контроллера

int error = 0;
byte type = 0;
byte vibrate = 0;

boolean up = false;
boolean down = false;
boolean left = false;
boolean right = false;
boolean pump = false;
boolean qwerty = true;

void setup() {
  for (int i = 3; i <= 13; i++)pinMode(i, OUTPUT);
  Serial.begin(57600);
  delay(300);
  //установка пинов и настроек: GamePad(clock, command, attention, data, Pressures?, Rumble?) проверка ошибок
  error = ps2x.config_gamepad(PS2_CLK, PS2_CMD, PS2_SEL, PS2_DAT, pressures, rumble);
  type = ps2x.readType();
  digitalWrite(speed_right_wheel, 1);
  digitalWrite(speed_left_wheel, 1);
  digitalWrite(pump_pin, 0);
}
/***************************************************************************************************************************************************/

void stick_move() {//не работает
  byte x = ps2x.Analog(PSS_RX);
  byte y = ps2x.Analog(PSS_RY);
  Serial.print(x);
  Serial.print(", ");
  Serial.println(y);

  boolean R, L;
  if (y < 128) { //верхняя половина
    if (x > 128) { // 1 четверть

    } else if (x < 128) { //2 четверть

    }
  } else if (y > 128) { //нижняя половина
    if (x < 128) { //3 четверть

    } else if (x > 128) { //4 чеверть

    }
  }
}
//////////////////////////////////////////////
void button_move() {
  if (ps2x.NewButtonState()) {
    if (ps2x.ButtonPressed(PSB_CIRCLE)) {
      up = false;
      down = false;
      left = false;
      right = false;
      pump = false;
      Serial.println("Circle pressed");
    }
    if (ps2x.NewButtonState(PSB_TRIANGLE)) {
      pump = !pump;
      digitalWrite(pump_pin, pump);
      Serial.print("pump");
      Serial.println(pump);
    }
    if (ps2x.NewButtonState(PSB_PAD_UP)) {
      up = !up;
      ps2x.read_gamepad(!up, 60);
      digitalWrite(right_wheel_forward, up);
      digitalWrite(left_wheel_forward, up);
      digitalWrite(right_wheel_back, 0);
      digitalWrite(left_wheel_back, 0);
      Serial.print("forward");
      Serial.println(up);
    }
    if (ps2x.NewButtonState(PSB_PAD_DOWN)) {
      down = !down;
      ps2x.read_gamepad(!down, 60);
      digitalWrite(right_wheel_forward, 0);
      digitalWrite(left_wheel_forward, 0);
      digitalWrite(right_wheel_back, down);
      digitalWrite(left_wheel_back, down);
      Serial.print("back");
      Serial.println(down);
    }
    if (ps2x.NewButtonState(PSB_PAD_RIGHT)) {
      right = !right;
      ps2x.read_gamepad(!right, 60);
      digitalWrite(right_wheel_forward, 0);
      digitalWrite(left_wheel_forward, right);
      digitalWrite(right_wheel_back, right);
      digitalWrite(left_wheel_back, 0);
      Serial.print("right");
      Serial.println(right);
    }
    if (ps2x.NewButtonState(PSB_PAD_LEFT)) {
      left = !left;
      ps2x.read_gamepad(!left, 60);
      digitalWrite(right_wheel_forward, left);
      digitalWrite(left_wheel_forward, 0);
      digitalWrite(right_wheel_back, 0);
      digitalWrite(left_wheel_back, left);
      Serial.print("left");
      Serial.println(left);
    }
  }
}

/******************************************************************************************************************************************************************************************************************/
void loop() {
  ps2x.read_gamepad();
  button_move();
  delay(50);
}
